#!/usr/bin/perl
print "Content-type: text/html\n\n";

if ($ENV{"REQUEST_METHOD"} eq "POST") {
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});		
}
elsif (exists $ENV{"REQUEST_METHOD"}) {		# data from GET transaction (or HEAD or other)
  $datastring = $ENV{"QUERY_STRING"};
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
$datastring =~s/%0D%0A/\n/g;                    			#step to deal with line
																											#breaks in text areas
@nameValuePairs = split(/&/, $datastring);						#step 1
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);								#step 2
  
  $name =~tr/+/ /;                                 		#step 3
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; 		#step 3
  $value =~tr/+/ /;                                		#step 3
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;		#step 3
  
  if(exists $formHash{$name}) {												#improved step 4,
    $formHash{$name} = $formHash{$name}.";".$value;		#now handles multiple
  }																										#select menus
  else {
    $formHash{$name} = $value;
  }   	
}
###done decoding###############################################

### global variables ##########################################
$rootDir = "music/";
$baseURL = "http://www.cknuckles.com/webapps/downloads/source/chap12/sitesearch/music/";
### end global variables ######################################


$searchstring = $formHash{"searchstring"};

print<<TOP;
 <html><head><title>Search Results in Music</title></head>
 <body>
 <img src="music.gif" alt="navigation bar" /><br />
TOP

&printForm($searchstring);

print '<hr width="600" align="left" />Here are the results of your search:<ol>';

&recursiveSearch($searchstring, $rootDir, $baseURL);

print<<BOTTOM;
 </ol>
 <hr width="150" align="left" />
 <a href="music.html">Back to Music Home Page</a>
 </body>
 </html>
BOTTOM

################################################################ 
sub printForm {
  my $initialstring = $_[0];
  print<<FORM;
  <form action="sitesearch.cgi" method="GET">
   Search music 
   <input type="text" name="searchstring" value="$initialstring" size="15"/>
   <input type="submit" value="Go"/>
  </form>
FORM
}
################################################################ 
sub recursiveSearch{
  my ($searchstring, $dir, $url) = @_;
  
  if(opendir(DIR, $dir)) {
    my @contents = readdir(DIR);
    closedir(DIR);
    
    foreach $item (@contents) {
      if(-d "$dir$item") {
        if($item !~ /^\./){ # to make sure it does not begin with a .
          &recursiveSearch($searchstring, "$dir$item/", "$url$item/");
        }
      }
      else {
      	if(($item =~/\.html$/i) && open(FILE, "$dir$item")) {
print "yes/$searchstring/\n";
        	my @lines = <FILE>;
        	close(FILE);
        	my $wholefile = join("", @lines);
 print "nek";       	
$x="555";
$s="";
if($x=~/$s/){print "yek";}

        	if($wholefile =~ /$searchstring/i) {
print "here1 ";
          	print "<li><a href=\"$url$item\">$url$item</a></li>";
         }# if
       }#if
     }#else
   }#foreach
  }#if
}#sub recursiveSearch




